//------------------------------------------------------------------
// idea by engula
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_level1  0

//
//
//
//
//

extern int VelPeriod      = 1;
extern int CmaHalfPeriod1 = 15;
extern int CmaHalfPeriod2 = 5;
extern int CmaPrice       = PRICE_CLOSE;

//
//
//
//
//

double cmo[];
double ma1[];
double ma2[];
double diff[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,cmo);
   SetIndexBuffer(1,ma1);
   SetIndexBuffer(2,ma2);
   SetIndexBuffer(3,diff);
   IndicatorShortName("CMA momentum ("+CmaHalfPeriod1+","+CmaHalfPeriod2+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,k,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,MathMax(CmaHalfPeriod1,CmaHalfPeriod2)),Bars-1);

   //
   //
   //
   //
   //

         for(i=limit; i>=0; i--)
         {
            ma1[i] = iMA(NULL,0,CmaHalfPeriod1,0,MODE_SMA,CmaPrice,i);
            ma2[i] = iMA(NULL,0,CmaHalfPeriod2,0,MODE_SMA,CmaPrice,i);
         }            
         for(i=limit; i>=0; i--)
         {
               double sum1 = ma1[i]; for (k=1; k<CmaHalfPeriod1; k++) { sum1 += ma1[i+k]; sum1 += ma1[toInt(MathMax(i-k,0))]; } sum1 /= ((2.0*CmaHalfPeriod1)-1.0);
               double sum2 = ma2[i]; for (k=1; k<CmaHalfPeriod2; k++) { sum2 += ma2[i+k]; sum2 += ma2[toInt(MathMax(i-k,0))]; } sum2 /= ((2.0*CmaHalfPeriod2)-1.0);
               diff[i] = sum2-sum1;
               cmo[i]  = diff[i]-diff[i+VelPeriod];
         }            
         return(0);
}

int toInt(int value) { return(value); }


